<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              http://www.exapartners.com/
 * @since             1.0.0
 * @package           Esi_Management
 *
 * @wordpress-plugin
 * Plugin Name:       ESI management
 * Plugin URI:        esi-management
 * Description:       This is a short description of what the plugin does. It's displayed in the WordPress admin area.
 * Version:           1.0.0
 * Author:            Kremer Nicolas
 * Author URI:        http://www.exapartners.com/
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       esi-management
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-esi-management-activator.php
 */
function activate_esi_management() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-esi-management-activator.php';
	Esi_Management_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-esi-management-deactivator.php
 */
function deactivate_esi_management() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-esi-management-deactivator.php';
	Esi_Management_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_esi_management' );
register_deactivation_hook( __FILE__, 'deactivate_esi_management' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-esi-management.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_esi_management() {

	$plugin = new Esi_Management();
	$plugin->run();

}
run_esi_management();
